# SPDX-License-Identifier: MIT
%dnl
%dnl Complete Go packaging template.

%dnl Forge macros are documented in macros.forge.
%global forge_url0 
%global tag0       
%global commit0    

%global forge_url1 
%global tag1       
%global commit1    

%dnl Omit the following line unless you have some use for forge variables
%dnl before the %go_pkg line:
%dnl   – %go_pkg  calls %go_init
%dnl   – %go_init calls %forge_init
%dnl Forge macros are documented in macros.forge.
%forge_init

%dnl SRPM-wide tags, when not set so far
Version: 
Release: 1%{dist}

%dnl A convenience block of text that can be reused in the subsequent
%dnl declarations
%global common_description %{expand:
}

%dnl Source package (SRPM) declarations
%global    source_name       
%global    source_summary    
%global    source_license    
%dnl You can add SRPM specific text bellow %{?common_description}, that won’t
%dnl appear in Go subpackages
%global    source_description %{expand:
%{?common_description}
}

%dnl The list of packaged Go modules, with their properties (one variable block
%dnl per module):
%dnl   — in usual rpm declaration style, %{gofoo0} and %{gofoo} are equivalent.
%dnl   – if you try to set them to different values, only one will be kept.
%dnl
%dnl The module path; it may differ from the URL where the project source is
%dnl published:
%dnl   – default value, %{goipathX}
%dnl   – this is done for backwards compatibility with pre-module distribution
%dnl     spec files. However, Go module paths and Go import paths have
%dnl     different semantics, making this fallback unsafe. It will be removed
%dnl     in the future.
%dnl   – if %{goipathX} is also not set, computed from %{go_urlX}
%global go_module0           
%dnl
%dnl The root URL where the project source is published:
%dnl   — default value, computed from %{go_moduleX}
%dnl   — because Go module paths contain major versions, but Go does not
%dnl     require creating the corresponding directories in source code trees,
%dnl     %{go_urlX} may differ from this direct %{go_moduleX} derivation
%dnl   – likewise Go sub-modules, will share a single project %{go_urlX}
%dnl     value, but use separate %{go_moduleX} module paths values
%dnl   — therefore, while %{go_urlX} is expected to match one of the
%dnl     %{forgeurlY} declared in the spec file, X and Y may differ
%global go_url0              %{forgeurl0}
%dnl The module tag, if it follows the Go semver conventions. Do not bother
%dnl setting it otherwise.
%dnl   – default value: the %{tagY}, matching the %{forgeurlY} used as
%dnl     %{go_urlX}
%global     go_tag0          
%dnl
%dnl The A.B.C part of the module version:
%dnl   — default value: the %{versionY}, matching the %{forge_urlY} used as
%dnl     %{go_urlX}
%dnl   – if %{versionY} is also not set, will fallback to %{version}.
%global go_version0          
%dnl
%dnl A preversion string, such as “pre” or “pre1” to use in module versionning:
%dnl   – due to the lax way preversions are defined in Go, use of this facility
%dnl     is not recommended.
%global go_pre0              
%dnl
%dnl The commit hash to use in module versionning:
%dnl   — default value: the %{commitY}, matching the %{forge_urlY} used as
%dnl     %{go_urlX}
%dnl   — if %{commitY} is also not set, automation will assume the git export
%dnl     perfectly matches %{go_versionX} or %{go_versionX}~%{go_preX}
%dnl   – if %{go_commitX} or %{commitY} are set, the macros will generate rpm
%dnl     and Go version strings anterior to %{go_versionX}, and posterior to
%dnl     %{go_versionX}~%{go_preX} if %{go_preX} has been set. Go documentation
%dnl     calls that vX.Y.(Z+1) pseudo-versionning, beware of the confusion
%dnl   — the Go module system does not support post-release commit
%dnl     declarations. Pseudo-versionning always refers to the next release
%dnl     version.
%global go_commit0           
%dnl
%dnl The timestamp associated with the commit, in RFC 3339 format:
%dnl   — default value: the %{timeY}, matching the %{forgeurlY} used as
%dnl     %{go_urlX}
%dnl   — RFC 3339 format as produced by “date -u --iso-8601=seconds”
%global go_time0             
%dnl
%dnl The rpm naming root of the packages related with this module:
%dnl   — when not set, computed from %{go_moduleX}
%dnl   – that is the usual case, please do not override %{go_name} unless you
%dnl     understand the consequences
%global go_name              
%dnl
%dnl A compatibility id that should be used in the package naming:
%dnl   – it will change the generated %{go_name} to compat-<go_name>-gocid
%dnl   — that allows packaging different states of the same module path in the
%dnl     distribution.
%dnl   – the “compat” naming is a human-level disambiguation to make clear
%dnl     which distribution package is supposed to provide the canonical state
%dnl     of a module. It does not change built-in Go version resolution
%dnl     mecanisms. Therefore, packagers introducing a compatibility package
%dnl     within the distribution, MUST make sure the result does not take
%dnl     precedence over the canonical distribution package.
%dnl  — common %{go_cidX} values:
%dnl      — a specific minor (A.B) or patch (A.B.C) version
%dnl      – a shortened commit tag such as
%dnl        %{lua:print(string.sub(rpm.expand("%{?commitX}"), 1, 7))}
%dnl      — since Go modules have no concept of post-release commits, it is not
%dnl        possible to package a commit without also initiating the packaging
%dnl        of the next project version.
%global go_cid               
%dnl
%dnl The module license:
%dnl   — default value: %{go_license}
%global go_license0          
%dnl
%dnl Shell globs matching the Go module license files
%dnl   — default value: %{go_licenses}
%global go_licenses0         
%dnl
%dnl Shell globs matching files to exclude from %{go_licensesX}
%dnl   — default value: %{go_licenses_exclude}
%global go_licenses_exclude0 
%dnl
%dnl Shell globs matching the Go module documentation files
%dnl   — default value %{go_docs}
%global go_docs0             
%dnl
%dnl Shell globs matching files to exclude from %{go_docsX}
%dnl   — default value:  %{go_docs_exclude}
%dnl   — common  value:  %{go_licensesX}
%global go_docs_exclude0      %{go_licenses0}
%dnl
%dnl A summary line, describing the Go project
%dnl   – only used in SRPM headers for now
%dnl   — default value:  %{go_module_summaryX}
%global go_summary0          
%dnl
%dnl A functionnal description of the Go project
%dnl   – can reuse text blocks such as %{?common_description}
%global go_description0      %{expand:
%{?common_description}
}
%dnl
%dnl The Go module subpackage summary line
%dnl   – default: computed
%global go_module_summary0    
%dnl A container for optional declarations in the go module package header
%global go_module_header0     %{expand:
}
%dnl
%dnl The Go import path (GOPATH) subpackage summary line
%dnl   – default: computed
%global go_devel_summary0     
%dnl
%dnl A container for optional declarations in the go module package header
%global go_devel_header0   %{expand:
}

%global go_module1             
%global go_url1                
%global go_license1            
%global go_licenses1           
%global go_licenses_exclude1   
%global go_docs1               
%global go_docs_exclude1       
%global go_version1            
%global go_pre1                
%global go_commit1             
%global go_time1               
%global go_description1        %{expand:
%{?common_description}
}
%global go_module_header1      %{expand:
}
%global godevelheader1         %{expand:
}

%global go_module2             
%global go_url2                
%global go_license2            
%global go_licenses2           
%global go_licenses_exclude2   
%global go_docs2               
%global go_docs_exclude2       
%global go_version2            
%global go_pre2                
%global go_commit2             
%global go_time2               
%global go_description2        %{expand:
%{?common_description}
}
%global go_module_header2      %{expand:
}
%global godevelheader2         %{expand:
}

%dnl Omit the following line unless you have some use for Go variables before
%dnl the %go_pkg line:
%dnl   – %go_pkg  calls %go_init
%dnl   – %go_init calls %forge_init
%dnl
%dnl %go_init can be overriden by setting compted Go variables before the
%dnl %go_init call.
%dnl
%dnl Control variables, flags and arguments:
%dnl   -z [number]  process the zth block of definitions
%dnl   -v           be verbose
%dnl   -i           list the resulting variable values
%go_init

%dnl After this point it is no longer possible to declare SRPM-wide tags and
%dnl variables safely

%dnl Control variables, flags and arguments:
%dnl   -z [number]  process the zth block of definitions
%dnl   -v           be verbose
%go_pkg

%sourcelist
%forge_sources

%patchlist
%forge_patches

%prep
%dnl Control variables, flags and arguments:
%dnl   -z [number]  process the zth block of definitions
%dnl   -v           be verbose
%go_prep

%generate_buildrequires
%dnl Control variables, flags and arguments:
%dnl   -z [number]  process the zth block of definitions
%go_generate_buildrequires

%build
%dnl Control variables, flags and arguments:
%dnl   -z [number]  process the zth block of definitions
%go_build

%install
%dnl Control variables, flags and arguments:
%dnl   -z [number]  process the zth block of definitions
%go_install

%check
%dnl Control variables, flags and arguments:
%dnl   -z [number]  process the zth block of definitions
%go_check

%dnl Control variables, flags and arguments:
%dnl   -z [number]  process the zth block of definitions
%go_files

%changelog

